import {world, system, EquipmentSlot, ItemStack, EntityEquippableComponent} from "@minecraft/server";

system.runInterval( () =>{
  try{
    for(let p of world.getPlayers()){
      let equip = p.getComponent(EntityEquippableComponent.componentId);
      let hand = equip.getEquipment(EquipmentSlot.Mainhand);
      let offhand = equip.getEquipment(EquipmentSlot.Offhand);
      let light13 = ["new:torch_offhand", "minecraft:torch"]
      let light11 = ["minecraft:soul_torch", "new:soul_torch_offhand"]
      let light9 = ["minecraft:redstone_torch", "new:redstone_torch_offhand"]
      let light_offhand = ["new:soul_torch_offhand", "new:redstone_torch_offhand", "new:torch_offhand", "new:sea_pickle"]
      let light_all = ["minecraft:redstone_torch", "new:redstone_torch_offhand", "minecraft:soul_torch", "new:soul_torch_offhand", "new:torch_offhand", "minecraft:torch", "new:sea_pickle", "minecraft:sea_pickle"]


      for(let offlight of light_offhand){
        if(p.hasTag("offhand") && !p.hasTag("mainhand")){
          p.removeTag("offhand")
          p.runCommandAsync(`execute as @s[hasitem={item=${offlight},location=slot.weapon.offhand,quantity=0}] run function no_light`);
        }
      }
      for(let light of light_all){
        if(p.hasTag("mainhand") && !p.hasTag("offhand")){
          p.removeTag("mainhand")
          p.runCommandAsync(`execute as @s[hasitem={item=${light},location=slot.weapon.mainhand,quantity=0}] run function no_light`);
        }
      }
      if(offhand){
        if(offhand.typeId.includes("new:torch_offhand")){
          p.addTag("offhand")
          p.runCommandAsync(`execute as @s positioned ~~1~ run function light13`);
        }
        if(offhand.typeId.includes("new:sea_pickle_offhand")){
          p.addTag("offhand")
          p.runCommandAsync(`execute as @s positioned ~~1~ run function sea_pickle`);
        }
        if(offhand.typeId.includes("soul_torch_offhand")){
          p.addTag("offhand")
          p.runCommandAsync(`execute as @s positioned ~~1~ run function light11`);
        }
        if(offhand.typeId.includes("redstone_torch_offhand")){
          p.addTag("offhand")
          p.runCommandAsync(`execute as @s positioned ~~1~ run function light9`);
        }
      }

      if(hand && !p.hasTag("offhand")){
        for(let l13 of light13){
          if(hand.typeId.includes(l13)){
            p.addTag("mainhand")
            p.runCommandAsync(`execute as @s positioned ~~1~ run function light13`);
          }
        }
        if(hand.typeId.includes("sea_pickle")){
          p.addTag("mainhand")
          p.runCommandAsync(`execute as @s positioned ~~1~ run function sea_pickle`);
        }
        for(let l11 of light11){
          if(hand.typeId.includes(l11)){
            p.addTag("mainhand")
            p.runCommandAsync(`execute as @s positioned ~~1~ run function light11`);
          }
        }
        for(let l9 of light9){
          if(hand.typeId.includes(l9)){
            p.addTag("mainhand")
            p.runCommandAsync(`execute as @s positioned ~~1~ run function light9`);
          }
        }
      }
    } 
  }catch(e){

  }
})


world.afterEvents.itemUse.subscribe(use =>{
  let item = use.itemStack;
  let p = use.source;
  let equip = p.getComponent(EntityEquippableComponent.componentId);
  let off = equip.getEquipment(EquipmentSlot.Offhand);
  if(item.typeId == "minecraft:torch" || item.typeId == "new:torch_offhand"){
    if(off == undefined){
      let testItem = item.typeId
      system.runTimeout(()=>{
        let main = equip.getEquipment(EquipmentSlot.Mainhand);
        if(main){
          if(main.typeId == testItem){
            let itemReplace = new ItemStack("new:torch_offhand", item.amount)
            let air = new ItemStack("minecraft:air")
            equip.setEquipment(EquipmentSlot.Offhand, itemReplace)
            equip.setEquipment(EquipmentSlot.Mainhand, air)
          }
        }
      }, 2)
    }
  }
  if(item.typeId == "minecraft:redstone_torch" || item.typeId == "new:redstone_torch_offhand"){
    if(off == undefined){
      let testItem = item.typeId
      system.runTimeout(()=>{
        let main = equip.getEquipment(EquipmentSlot.Mainhand);
        if(main){
          if(main.typeId == testItem){
            let itemReplace = new ItemStack("new:redstone_torch_offhand", item.amount)
            let air = new ItemStack("minecraft:air")
            equip.setEquipment(EquipmentSlot.Offhand, itemReplace)
            equip.setEquipment(EquipmentSlot.Mainhand, air)
          }
        }
      }, 2)
    }
  }
  if(item.typeId == "minecraft:soul_torch" || item.typeId == "new:soul_torch_offhand"){
    if(off == undefined){
      let testItem = item.typeId
      system.runTimeout(()=>{
        let main = equip.getEquipment(EquipmentSlot.Mainhand);
        if(main){
          if(main.typeId == testItem){
            let itemReplace = new ItemStack("new:soul_torch_offhand", item.amount)
            let air = new ItemStack("minecraft:air")
            equip.setEquipment(EquipmentSlot.Offhand, itemReplace)
            equip.setEquipment(EquipmentSlot.Mainhand, air)
          }
        }
      }, 2)
    }
  }
})